Index: /ruby/trunk/lib/adl_parser/lib/parser.rb
===================================================================
--- /ruby/trunk/lib/adl_parser/lib/parser.rb	(revision 317)
+++ /ruby/trunk/lib/adl_parser/lib/parser.rb	(revision 318)
@@ -27,5 +27,5 @@
     class Parser < Racc::Parser
 
-module_eval(<<'...end parser.y/module_eval...', 'parser.y', 1282)
+module_eval(<<'...end parser.y/module_eval...', 'parser.y', 1283)
 
 def assert_at(file,line, message = "")
@@ -155,5 +155,5 @@
    129,   462,   497,   577,   229,   476,    58,   137,    67,   213,
    381,   335,   330,   564,   152,   154,    25,    26,   529,   125,
-   127,   113,    72,   495,   189,  -373,    30,   516,   518,    36,
+   127,   113,    72,   495,   189,  -374,    30,   516,   518,    36,
    521,   523,   214,   520,   443,    36,    60,   230,   144,   152,
    154,   431,    48,    50,   274,   110,   435,    80,    83,    86,
@@ -178,5 +178,5 @@
     80,   385,   386,   237,   149,   150,   157,     1,   341,   248,
    261,   172,    22,   254,   338,   379,   258,   260,   145,   157,
-   117,   149,   150,   146,   157,   115,     4,   157,   119,  -372,
+   117,   149,   150,   146,   157,   115,     4,   157,   119,  -373,
     23,    80,    83,    86,   218,   247,    96,   269,   156,   391,
    218,   238,   570,   149,   150,   159,   218,    80,   385,   386,
@@ -221,5 +221,5 @@
    115,   117,   119,    80,    83,    86,   353,   354,    96,    80,
    385,   386,   113,   115,   117,   119,   389,    80,   385,   386,
-   272,   275,   276,  -102,   355,   356,   288,   175,   422,   423,
+   272,   275,   276,  -103,   355,   356,   288,   175,   422,   423,
     80,    83,    86,   193,   451,    96,   125,   127,   109,   113,
    115,   117,   119,   189,   122,   110,   363,   364,    80,    83,
@@ -237,5 +237,5 @@
    546,    56,   548,   113,   550,   115,   552,   117,   554,   119,
    267,   557,   558,   559,   560,   561,   562,   119,   119,   119,
-   119,   563,   249,   162,  -102,   568,   115,    53,    34,   172,
+   119,   563,   249,   162,  -103,   568,   115,    53,    34,   172,
    268,    31,   579,    28,   581,   582,   583,   584,   585,   586,
    587,   113,   590,   591,   592,    24,   595,   596,   269,    21,
@@ -404,67 +404,67 @@
 
 racc_action_default = [
-  -375,    -2,  -375,  -375,    -6,  -375,   -13,    -4,  -375,    -5,
-    -7,  -375,    -1,  -375,  -375,   632,  -375,   -12,  -375,    -9,
-   -18,  -375,   -15,   -14,  -375,    -8,  -375,   -21,  -375,   -17,
-   -16,   -11,   -10,  -375,  -375,  -111,   -93,   -89,   -19,  -107,
-  -375,   -20,  -375,   -97,   -98,   -99,  -375,  -375,  -145,   -87,
-  -146,   -88,   -82,  -375,   -22,   -23,   -94,  -375,  -109,  -375,
-  -375,  -375,  -103,  -375,  -108,  -100,   -90,  -375,  -375,  -375,
-  -288,  -281,  -375,  -247,   -25,   -24,  -252,   -26,  -283,  -253,
-  -151,   -27,  -375,  -375,  -375,  -375,  -375,  -272,  -304,  -273,
-  -375,  -375,  -285,  -282,  -375,  -250,  -166,   -31,  -270,  -280,
-  -271,  -375,  -111,   -92,  -112,   -96,  -375,   -95,  -110,  -186,
-  -147,  -122,  -375,  -190,  -123,  -203,  -124,  -216,  -125,  -229,
-  -126,  -127,  -246,  -128,  -129,  -181,  -120,  -182,  -121,  -101,
-  -104,  -375,   -91,   -84,   -83,  -375,    -3,  -287,  -375,  -288,
-  -284,  -248,  -372,  -375,  -375,  -152,  -167,  -375,  -375,  -375,
-  -375,  -375,  -375,  -375,  -375,  -375,  -375,  -375,  -375,  -153,
-  -168,   -30,  -375,  -255,  -254,  -375,  -258,  -375,  -375,  -375,
-  -375,  -375,   -32,  -375,  -375,  -147,  -144,  -133,  -122,  -115,
-  -134,  -123,  -135,  -124,  -136,  -125,  -137,  -126,  -375,  -242,
-  -138,  -127,  -116,  -375,  -139,  -128,  -117,  -140,  -118,  -141,
-  -130,  -119,  -142,  -131,  -143,  -132,  -121,  -113,  -106,  -105,
-   -85,   -86,  -375,  -375,  -375,  -286,  -375,  -262,  -375,  -277,
-  -278,  -263,  -274,  -264,  -275,  -260,  -259,  -276,  -261,  -306,
-  -375,  -251,  -249,  -266,  -267,  -268,  -265,  -279,  -269,  -375,
-  -375,  -375,  -375,  -375,  -375,  -375,  -375,  -375,  -375,  -375,
-  -114,  -375,  -375,  -375,  -375,  -375,  -375,  -375,  -375,  -375,
-  -375,  -375,  -375,  -375,  -375,  -375,  -375,  -375,  -375,  -375,
-  -375,  -342,  -321,  -315,  -346,  -327,  -333,  -312,  -375,  -322,
-  -318,   -54,  -328,  -324,   -55,  -334,  -330,   -56,  -374,  -341,
-  -336,  -311,   -57,  -343,  -317,   -58,  -339,  -323,  -347,   -59,
-  -352,  -349,  -329,  -310,   -60,  -356,  -353,  -335,  -316,  -309,
-   -61,  -375,  -289,   -63,  -375,  -375,   -33,   -62,   -34,  -375,
-  -375,  -148,  -150,  -184,  -169,  -171,  -375,  -375,  -188,  -183,
-  -185,  -192,  -189,  -187,  -205,  -193,  -191,  -218,  -206,  -204,
-  -231,  -219,  -217,  -180,  -375,  -375,  -375,  -375,  -375,  -375,
-  -375,  -202,  -375,  -215,  -375,  -228,  -375,  -375,  -375,  -375,
-  -375,  -375,  -375,  -241,  -375,  -375,  -375,  -375,  -375,  -375,
-  -375,  -375,  -375,  -375,  -375,  -375,  -375,  -165,  -375,  -232,
-  -230,  -245,  -243,  -149,  -244,  -375,  -375,  -155,  -170,  -156,
-  -154,   -28,  -375,  -256,  -375,  -375,  -375,  -375,  -375,  -375,
-  -375,  -375,  -375,  -375,  -375,  -257,   -68,  -375,  -375,   -29,
-   -64,  -375,  -307,  -151,  -303,  -302,  -375,  -375,  -178,  -375,
-  -200,  -375,  -213,  -375,  -226,  -375,  -239,  -375,  -163,  -375,
-  -375,  -375,  -375,  -375,  -375,  -375,  -177,  -199,  -212,  -225,
-  -238,  -162,  -375,  -375,  -179,  -201,  -214,  -227,  -240,  -164,
-  -176,  -198,  -211,  -224,  -237,  -161,  -375,  -375,  -314,  -313,
-  -319,  -320,  -326,  -325,  -332,  -331,  -338,  -337,  -345,  -344,
-  -340,  -375,  -348,  -354,  -351,  -350,  -358,  -357,  -355,   -69,
-  -375,  -375,  -375,  -375,  -305,  -375,  -172,  -375,  -375,  -375,
-  -375,  -375,  -375,  -375,  -375,  -375,  -375,  -375,  -375,  -375,
-  -194,  -375,  -207,  -375,  -220,  -375,  -233,  -375,  -375,  -157,
-  -375,  -375,  -375,  -375,  -375,  -375,   -43,  -304,  -375,   -53,
-   -44,  -375,  -309,  -375,   -31,   -72,   -70,   -36,   -37,  -371,
-   -38,  -359,   -39,  -362,   -40,  -375,  -365,   -41,  -366,   -42,
-  -368,  -375,   -35,  -375,  -308,  -174,  -173,  -375,  -195,  -375,
-  -208,  -375,  -221,  -375,  -234,  -375,  -375,  -158,  -196,  -209,
-  -222,  -235,  -159,  -375,  -291,  -375,   -49,  -375,   -67,  -304,
-  -375,   -52,   -50,  -375,  -375,   -44,   -71,   -65,  -375,  -369,
-  -375,   -66,  -175,  -197,  -210,  -223,  -236,  -160,  -294,  -375,
-  -375,  -290,   -45,   -47,  -375,  -364,   -51,  -363,  -375,  -361,
-  -360,  -367,  -370,   -73,  -375,  -293,  -292,   -46,  -375,   -75,
-  -295,  -296,  -297,   -74,   -77,  -375,   -80,  -375,  -375,  -375,
-  -375,  -375,   -78,  -375,   -48,   -76,  -298,  -299,  -300,  -301,
+  -376,    -2,  -376,  -376,    -6,  -376,   -13,    -4,  -376,    -5,
+    -7,  -376,    -1,  -376,  -376,   632,  -376,   -12,  -376,    -9,
+   -18,  -376,   -15,   -14,  -376,    -8,  -376,   -21,   -87,   -17,
+   -16,   -11,   -10,  -376,   -87,  -112,   -94,   -90,   -19,  -108,
+  -376,   -20,  -376,   -98,   -99,  -100,  -376,  -376,  -146,   -88,
+  -147,   -89,   -82,  -376,   -22,   -23,   -95,  -376,  -110,  -376,
+  -376,  -376,  -104,  -376,  -109,  -101,   -91,  -376,  -376,  -376,
+  -289,  -282,  -376,  -248,   -25,   -24,  -253,   -26,  -284,  -254,
+  -152,   -27,  -376,  -376,  -376,  -376,  -376,  -273,  -305,  -274,
+  -376,  -376,  -286,  -283,  -376,  -251,  -167,   -31,  -271,  -281,
+  -272,  -376,  -112,   -93,  -113,   -97,  -376,   -96,  -111,  -187,
+  -148,  -123,  -376,  -191,  -124,  -204,  -125,  -217,  -126,  -230,
+  -127,  -128,  -247,  -129,  -130,  -182,  -121,  -183,  -122,  -102,
+  -105,  -376,   -92,   -84,   -83,   -87,    -3,  -288,  -376,  -289,
+  -285,  -249,  -373,  -376,  -376,  -153,  -168,  -376,  -376,  -376,
+  -376,  -376,  -376,  -376,  -376,  -376,  -376,  -376,  -376,  -154,
+  -169,   -30,  -376,  -256,  -255,  -376,  -259,  -376,  -376,  -376,
+  -376,  -376,   -32,  -376,  -376,  -148,  -145,  -134,  -123,  -116,
+  -135,  -124,  -136,  -125,  -137,  -126,  -138,  -127,  -376,  -243,
+  -139,  -128,  -117,  -376,  -140,  -129,  -118,  -141,  -119,  -142,
+  -131,  -120,  -143,  -132,  -144,  -133,  -122,  -114,  -107,  -106,
+   -85,   -86,  -376,  -376,  -376,  -287,  -376,  -263,  -376,  -278,
+  -279,  -264,  -275,  -265,  -276,  -261,  -260,  -277,  -262,  -307,
+  -376,  -252,  -250,  -267,  -268,  -269,  -266,  -280,  -270,  -376,
+  -376,  -376,  -376,  -376,  -376,  -376,  -376,  -376,  -376,  -376,
+  -115,  -376,  -376,  -376,  -376,  -376,  -376,  -376,  -376,  -376,
+  -376,  -376,  -376,  -376,  -376,  -376,  -376,  -376,  -376,  -376,
+  -376,  -343,  -322,  -316,  -347,  -328,  -334,  -313,  -376,  -323,
+  -319,   -54,  -329,  -325,   -55,  -335,  -331,   -56,  -375,  -342,
+  -337,  -312,   -57,  -344,  -318,   -58,  -340,  -324,  -348,   -59,
+  -353,  -350,  -330,  -311,   -60,  -357,  -354,  -336,  -317,  -310,
+   -61,  -376,  -290,   -63,  -376,  -376,   -33,   -62,   -34,  -376,
+  -376,  -149,  -151,  -185,  -170,  -172,  -376,  -376,  -189,  -184,
+  -186,  -193,  -190,  -188,  -206,  -194,  -192,  -219,  -207,  -205,
+  -232,  -220,  -218,  -181,  -376,  -376,  -376,  -376,  -376,  -376,
+  -376,  -203,  -376,  -216,  -376,  -229,  -376,  -376,  -376,  -376,
+  -376,  -376,  -376,  -242,  -376,  -376,  -376,  -376,  -376,  -376,
+  -376,  -376,  -376,  -376,  -376,  -376,  -376,  -166,  -376,  -233,
+  -231,  -246,  -244,  -150,  -245,  -376,  -376,  -156,  -171,  -157,
+  -155,   -28,  -376,  -257,  -376,  -376,  -376,  -376,  -376,  -376,
+  -376,  -376,  -376,  -376,  -376,  -258,   -68,  -376,  -376,   -29,
+   -64,  -376,  -308,  -152,  -304,  -303,  -376,  -376,  -179,  -376,
+  -201,  -376,  -214,  -376,  -227,  -376,  -240,  -376,  -164,  -376,
+  -376,  -376,  -376,  -376,  -376,  -376,  -178,  -200,  -213,  -226,
+  -239,  -163,  -376,  -376,  -180,  -202,  -215,  -228,  -241,  -165,
+  -177,  -199,  -212,  -225,  -238,  -162,  -376,  -376,  -315,  -314,
+  -320,  -321,  -327,  -326,  -333,  -332,  -339,  -338,  -346,  -345,
+  -341,  -376,  -349,  -355,  -352,  -351,  -359,  -358,  -356,   -69,
+  -376,  -376,  -376,  -376,  -306,  -376,  -173,  -376,  -376,  -376,
+  -376,  -376,  -376,  -376,  -376,  -376,  -376,  -376,  -376,  -376,
+  -195,  -376,  -208,  -376,  -221,  -376,  -234,  -376,  -376,  -158,
+  -376,  -376,  -376,  -376,  -376,  -376,   -43,  -305,   -87,   -53,
+   -44,  -376,  -310,  -376,   -31,   -72,   -70,   -36,   -37,  -372,
+   -38,  -360,   -39,  -363,   -40,  -376,  -366,   -41,  -367,   -42,
+  -369,  -376,   -35,  -376,  -309,  -175,  -174,  -376,  -196,  -376,
+  -209,  -376,  -222,  -376,  -235,  -376,  -376,  -159,  -197,  -210,
+  -223,  -236,  -160,  -376,  -292,  -376,   -49,  -376,   -67,  -305,
+  -376,   -52,   -50,  -376,  -376,   -44,   -71,   -65,  -376,  -370,
+  -376,   -66,  -176,  -198,  -211,  -224,  -237,  -161,  -295,  -376,
+  -376,  -291,   -45,   -47,  -376,  -365,   -51,  -364,  -376,  -362,
+  -361,  -368,  -371,   -73,  -376,  -294,  -293,   -46,  -376,   -75,
+  -296,  -297,  -298,   -74,   -77,  -376,   -80,  -376,  -376,  -376,
+  -376,  -376,   -78,  -376,   -48,   -76,  -299,  -300,  -301,  -302,
    -81,   -79 ]
 
@@ -707,38 +707,38 @@
   2, 105, :_reduce_85,
   2, 105, :_reduce_none,
-  1, 110, :_reduce_87,
+  0, 110, :_reduce_none,
   1, 110, :_reduce_88,
-  1, 152, :_reduce_89,
-  2, 152, :_reduce_90,
-  3, 152, :_reduce_91,
-  3, 154, :_reduce_92,
-  1, 155, :_reduce_93,
+  1, 110, :_reduce_89,
+  1, 152, :_reduce_90,
+  2, 152, :_reduce_91,
+  3, 152, :_reduce_92,
+  3, 154, :_reduce_93,
+  1, 155, :_reduce_94,
   2, 155, :_reduce_none,
-  1, 156, :_reduce_95,
   1, 156, :_reduce_96,
-  1, 153, :_reduce_97,
+  1, 156, :_reduce_97,
   1, 153, :_reduce_98,
-  1, 159, :_reduce_99,
-  2, 159, :_reduce_100,
-  3, 160, :_reduce_101,
-  1, 161, :_reduce_102,
-  1, 162, :_reduce_103,
-  2, 162, :_reduce_104,
-  3, 163, :_reduce_105,
-  3, 164, :_reduce_106,
-  1, 158, :_reduce_107,
-  2, 158, :_reduce_108,
-  2, 166, :_reduce_109,
-  3, 166, :_reduce_110,
+  1, 153, :_reduce_99,
+  1, 159, :_reduce_100,
+  2, 159, :_reduce_101,
+  3, 160, :_reduce_102,
+  1, 161, :_reduce_103,
+  1, 162, :_reduce_104,
+  2, 162, :_reduce_105,
+  3, 163, :_reduce_106,
+  3, 164, :_reduce_107,
+  1, 158, :_reduce_108,
+  2, 158, :_reduce_109,
+  2, 166, :_reduce_110,
+  3, 166, :_reduce_111,
   1, 167, :_reduce_none,
-  1, 157, :_reduce_112,
-  2, 157, :_reduce_113,
-  3, 168, :_reduce_114,
-  1, 169, :_reduce_115,
+  1, 157, :_reduce_113,
+  2, 157, :_reduce_114,
+  3, 168, :_reduce_115,
   1, 169, :_reduce_116,
   1, 169, :_reduce_117,
   1, 169, :_reduce_118,
   1, 169, :_reduce_119,
-  1, 165, :_reduce_120,
+  1, 169, :_reduce_120,
   1, 165, :_reduce_121,
   1, 165, :_reduce_122,
@@ -750,5 +750,5 @@
   1, 165, :_reduce_128,
   1, 165, :_reduce_129,
-  1, 170, :_reduce_130,
+  1, 165, :_reduce_130,
   1, 170, :_reduce_131,
   1, 170, :_reduce_132,
@@ -759,4 +759,5 @@
   1, 170, :_reduce_137,
   1, 170, :_reduce_138,
+  1, 170, :_reduce_139,
   1, 171, :_reduce_none,
   1, 171, :_reduce_none,
@@ -765,13 +766,13 @@
   1, 171, :_reduce_none,
   1, 171, :_reduce_none,
-  1, 118, :_reduce_145,
   1, 118, :_reduce_146,
-  1, 174, :_reduce_147,
-  3, 184, :_reduce_148,
+  1, 118, :_reduce_147,
+  1, 174, :_reduce_148,
   3, 184, :_reduce_149,
   3, 184, :_reduce_150,
-  1, 175, :_reduce_151,
-  2, 175, :_reduce_152,
+  3, 184, :_reduce_151,
+  1, 175, :_reduce_152,
   2, 175, :_reduce_153,
+  2, 175, :_reduce_154,
   3, 185, :_reduce_none,
   3, 185, :_reduce_none,
@@ -786,7 +787,7 @@
   4, 193, :_reduce_none,
   3, 193, :_reduce_none,
-  1, 176, :_reduce_166,
-  2, 176, :_reduce_167,
+  1, 176, :_reduce_167,
   2, 176, :_reduce_168,
+  2, 176, :_reduce_169,
   3, 186, :_reduce_none,
   3, 186, :_reduce_none,
@@ -801,6 +802,6 @@
   4, 194, :_reduce_none,
   3, 194, :_reduce_none,
-  1, 177, :_reduce_181,
   1, 177, :_reduce_182,
+  1, 177, :_reduce_183,
   3, 187, :_reduce_none,
   3, 187, :_reduce_none,
@@ -810,5 +811,5 @@
   3, 188, :_reduce_none,
   3, 188, :_reduce_none,
-  1, 179, :_reduce_190,
+  1, 179, :_reduce_191,
   3, 189, :_reduce_none,
   3, 189, :_reduce_none,
@@ -849,5 +850,5 @@
   4, 197, :_reduce_none,
   3, 197, :_reduce_none,
-  1, 182, :_reduce_229,
+  1, 182, :_reduce_230,
   3, 192, :_reduce_none,
   3, 192, :_reduce_none,
@@ -862,9 +863,9 @@
   4, 198, :_reduce_none,
   3, 198, :_reduce_none,
-  1, 172, :_reduce_242,
+  1, 172, :_reduce_243,
   3, 173, :_reduce_none,
   3, 173, :_reduce_none,
   3, 173, :_reduce_none,
-  1, 183, :_reduce_246,
+  1, 183, :_reduce_247,
   1, 113, :_reduce_none,
   2, 113, :_reduce_none,
@@ -907,11 +908,11 @@
   1, 202, :_reduce_none,
   3, 202, :_reduce_none,
-  2, 206, :_reduce_287,
-  1, 206, :_reduce_288,
-  0, 146, :_reduce_289,
-  5, 146, :_reduce_290,
-  1, 207, :_reduce_291,
-  3, 207, :_reduce_292,
-  5, 147, :_reduce_293,
+  2, 206, :_reduce_288,
+  1, 206, :_reduce_289,
+  0, 146, :_reduce_290,
+  5, 146, :_reduce_291,
+  1, 207, :_reduce_292,
+  3, 207, :_reduce_293,
+  5, 147, :_reduce_294,
   1, 208, :_reduce_none,
   3, 208, :_reduce_none,
@@ -922,11 +923,11 @@
   5, 208, :_reduce_none,
   5, 208, :_reduce_none,
-  1, 210, :_reduce_302,
   1, 210, :_reduce_303,
+  1, 210, :_reduce_304,
   0, 117, :_reduce_none,
-  5, 117, :_reduce_305,
+  5, 117, :_reduce_306,
   2, 117, :_reduce_none,
-  1, 209, :_reduce_307,
-  3, 209, :_reduce_308,
+  1, 209, :_reduce_308,
+  3, 209, :_reduce_309,
   1, 211, :_reduce_none,
   1, 211, :_reduce_none,
@@ -972,11 +973,11 @@
   3, 141, :_reduce_none,
   3, 141, :_reduce_none,
-  1, 219, :_reduce_352,
   1, 219, :_reduce_353,
-  3, 219, :_reduce_354,
+  1, 219, :_reduce_354,
   3, 219, :_reduce_355,
-  1, 142, :_reduce_356,
-  3, 142, :_reduce_357,
+  3, 219, :_reduce_356,
+  1, 142, :_reduce_357,
   3, 142, :_reduce_358,
+  3, 142, :_reduce_359,
   1, 126, :_reduce_none,
   3, 126, :_reduce_none,
@@ -984,17 +985,17 @@
   1, 220, :_reduce_none,
   3, 220, :_reduce_none,
-  3, 221, :_reduce_364,
-  1, 125, :_reduce_365,
+  3, 221, :_reduce_365,
   1, 125, :_reduce_366,
-  3, 222, :_reduce_367,
+  1, 125, :_reduce_367,
+  3, 222, :_reduce_368,
   0, 223, :_reduce_none,
   1, 223, :_reduce_none,
   2, 223, :_reduce_none,
-  1, 124, :_reduce_371,
-  1, 150, :_reduce_372,
+  1, 124, :_reduce_372,
   1, 150, :_reduce_373,
-  1, 217, :_reduce_374 ]
-
-racc_reduce_n = 375
+  1, 150, :_reduce_374,
+  1, 217, :_reduce_375 ]
+
+racc_reduce_n = 376
 
 racc_shift_n = 632
@@ -1362,5 +1363,5 @@
   def _reduce_3(val, _values, result)
         assert_at(__FILE__,__LINE__) do
-      val[4].instance_of?(OpenEhr::AM::Archetype::Archetype_Description::ARCHETYPE_DESCRIPTION) and val[5].instance_of?(OpenEhr::AM::Archetype::Constraint_Model::C_COMPLEX_OBJECT) and val[7].instance_of?(OpenEhr::AM::Archetype::Ontology::ARCHETYPE_ONTOLOGY) 
+      val[4].instance_of?(OpenEhr::AM::Archetype::Archetype_Description::ARCHETYPE_DESCRIPTION) and val[5].instance_of?(OpenEhr::AM::Archetype::ConstraintModel::C_COMPLEX_OBJECT) and val[7].instance_of?(OpenEhr::AM::Archetype::Ontology::ARCHETYPE_ONTOLOGY) 
     end
     
@@ -1524,5 +1525,5 @@
 module_eval(<<'.,.,', 'parser.y', 155)
   def _reduce_26(val, _values, result)
-        assert_at(__FILE__,__LINE__){val[0].instance_of?(OpenEhr::AM::Archetype::Constraint_Model::C_COMPLEX_OBJECT)}
+        assert_at(__FILE__,__LINE__){val[0].instance_of?(OpenEhr::AM::Archetype::ConstraintModel::C_COMPLEX_OBJECT)}
     @@logger.debug("#{__FILE__}:#{__LINE__}: c_complex_object = #{val[0]} at #{@filename}:#{@lineno}")
     result = val[0]
@@ -1542,5 +1543,5 @@
 module_eval(<<'.,.,', 'parser.y', 168)
   def _reduce_28(val, _values, result)
-        result = OpenEhr::AM::Archetype::Constraint_Model::C_COMPLEX_OBJECT.create(:attributes => val[3]) do |c_complex_object|
+        result = OpenEhr::AM::Archetype::ConstraintModel::C_COMPLEX_OBJECT.create(:attributes => val[3]) do |c_complex_object|
       c_complex_object.node_id = val[0][:c_complex_object_id][:local_term_code_ref]
       c_complex_object.rm_type_name = val[0][:c_complex_object_id][:type_identifier]
@@ -1554,5 +1555,5 @@
 module_eval(<<'.,.,', 'parser.y', 176)
   def _reduce_29(val, _values, result)
-        result = OpenEhr::AM::Archetype::Constraint_Model::C_COMPLEX_OBJECT.create(:attributes => val[3]) do |c_complex_object|
+        result = OpenEhr::AM::Archetype::ConstraintModel::C_COMPLEX_OBJECT.create(:attributes => val[3]) do |c_complex_object|
       c_complex_object.node_id = val[0][:c_complex_object_id][:local_term_code_ref]
       c_complex_object.rm_type_name = val[0][:c_complex_object_id][:type_identifier]
@@ -1592,5 +1593,5 @@
 module_eval(<<'.,.,', 'parser.y', 202)
   def _reduce_34(val, _values, result)
-        result = OpenEhr::AM::Archetype::Constraint_Model::C_COMPLEX_OBJECT.new(:attributes => val[0])
+        result = OpenEhr::AM::Archetype::ConstraintModel::C_COMPLEX_OBJECT.new(:attributes => val[0])
   
     result
@@ -1609,5 +1610,5 @@
 module_eval(<<'.,.,', 'parser.y', 225)
   def _reduce_36(val, _values, result)
-        result = OpenEhr::AM::Archetype::Constraint_Model::ARCHETYPE_INTERNAL_REF.create do |archetype_internal_ref|
+        result = OpenEhr::AM::Archetype::ConstraintModel::ARCHETYPE_INTERNAL_REF.create do |archetype_internal_ref|
       archetype_internal_ref.target_path = val[0][:absolute_path]
       archetype_internal_ref.rm_type_name = val[0][:type_identifier]
@@ -1629,5 +1630,5 @@
 module_eval(<<'.,.,', 'parser.y', 237)
   def _reduce_38(val, _values, result)
-        result = OpenEhr::AM::Archetype::Constraint_Model::CONSTRAINT_REF.create do |constraint_ref|
+        result = OpenEhr::AM::Archetype::ConstraintModel::CONSTRAINT_REF.create do |constraint_ref|
       constraint_ref.reference = val[0]
     end
@@ -1693,5 +1694,5 @@
 module_eval(<<'.,.,', 'parser.y', 301)
   def _reduce_48(val, _values, result)
-        result = OpenEhr::AM::Archetype::Constraint_Model::ARCHETYPE_SLOT.create do |archetype_slot|
+        result = OpenEhr::AM::Archetype::ConstraintModel::ARCHETYPE_SLOT.create do |archetype_slot|
       archetype_slot.includes = val[3]
       archetype_slot.excludes = val[4]
@@ -1726,6 +1727,6 @@
 module_eval(<<'.,.,', 'parser.y', 323)
   def _reduce_53(val, _values, result)
-        assert_at(__FILE__,__LINE__){val[0].kind_of?(OpenEhr::AM::Archetype::Constraint_Model::Primitive::C_PRIMITIVE)}
-    result = OpenEhr::AM::Archetype::Constraint_Model::C_PRIMITIVE_OBJECT.create do |c_primitive_object|
+        assert_at(__FILE__,__LINE__){val[0].kind_of?(OpenEhr::AM::Archetype::ConstraintModel::Primitive::C_PRIMITIVE)}
+    result = OpenEhr::AM::Archetype::ConstraintModel::C_PRIMITIVE_OBJECT.create do |c_primitive_object|
       c_primitive_object.item = val[0]
     end
@@ -1738,5 +1739,5 @@
   def _reduce_54(val, _values, result)
         @@logger.debug("#{__FILE__}:#{__LINE__}: c_integer = #{val[0]} at #{@filename}:#{@lineno}")
-    result = OpenEhr::AM::Archetype::Constraint_Model::Primitive::C_INTEGER.create do |c_integer|
+    result = OpenEhr::AM::Archetype::ConstraintModel::Primitive::C_INTEGER.create do |c_integer|
       c_integer.list
       c_integer.range
@@ -1751,5 +1752,5 @@
   def _reduce_55(val, _values, result)
         @@logger.debug("#{__FILE__}:#{__LINE__}: c_real = #{val[0]} at #{@filename}:#{@lineno}")
-    result = OpenEhr::AM::Archetype::Constraint_Model::Primitive::C_REAL.new
+    result = OpenEhr::AM::Archetype::ConstraintModel::Primitive::C_REAL.new
   
     result
@@ -1760,5 +1761,5 @@
   def _reduce_56(val, _values, result)
         @@logger.debug("#{__FILE__}:#{__LINE__}: c_date = #{val[0]} at #{@filename}:#{@lineno}")
-    result = OpenEhr::AM::Archetype::Constraint_Model::Primitive::C_DATE.new
+    result = OpenEhr::AM::Archetype::ConstraintModel::Primitive::C_DATE.new
   
     result
@@ -1769,5 +1770,5 @@
   def _reduce_57(val, _values, result)
         @@logger.debug("#{__FILE__}:#{__LINE__}: c_time = #{val[0]} at #{@filename}:#{@lineno}")
-    result = OpenEhr::AM::Archetype::Constraint_Model::Primitive::C_TIME.new
+    result = OpenEhr::AM::Archetype::ConstraintModel::Primitive::C_TIME.new
   
     result
@@ -1778,5 +1779,5 @@
   def _reduce_58(val, _values, result)
         @@logger.debug("#{__FILE__}:#{__LINE__}: c_date_time = #{val[0]} at #{@filename}:#{@lineno}")
-    result = OpenEhr::AM::Archetype::Constraint_Model::Primitive::C_DATE_TIME.new
+    result = OpenEhr::AM::Archetype::ConstraintModel::Primitive::C_DATE_TIME.new
   
     result
@@ -1787,5 +1788,5 @@
   def _reduce_59(val, _values, result)
         @@logger.debug("#{__FILE__}:#{__LINE__}: c_duration = #{val[0]} at #{@filename}:#{@lineno}")
-    result = OpenEhr::AM::Archetype::Constraint_Model::Primitive::C_DURATION.new
+    result = OpenEhr::AM::Archetype::ConstraintModel::Primitive::C_DURATION.new
   
     result
@@ -1796,5 +1797,5 @@
   def _reduce_60(val, _values, result)
         @@logger.debug("#{__FILE__}:#{__LINE__}: c_string = #{val[0]} at #{@filename}:#{@lineno}")
-    result = OpenEhr::AM::Archetype::Constraint_Model::Primitive::C_STRING.new
+    result = OpenEhr::AM::Archetype::ConstraintModel::Primitive::C_STRING.new
   
     result
@@ -1804,5 +1805,5 @@
 module_eval(<<'.,.,', 'parser.y', 370)
   def _reduce_61(val, _values, result)
-        assert_at(__FILE__,__LINE__){val[0].instance_of?(OpenEhr::AM::Archetype::Constraint_Model::Primitive::C_BOOLEAN)}
+        assert_at(__FILE__,__LINE__){val[0].instance_of?(OpenEhr::AM::Archetype::ConstraintModel::Primitive::C_BOOLEAN)}
     @@logger.debug("#{__FILE__}:#{__LINE__}: c_boolean = #{val[0]} at #{@filename}:#{@lineno}")
     result = val[0]
@@ -1832,5 +1833,5 @@
 module_eval(<<'.,.,', 'parser.y', 392)
   def _reduce_65(val, _values, result)
-        assert_at(__FILE__,__LINE__){ val[0].kind_of?(OpenEhr::AM::Archetype::Constraint_Model::C_ATTRIBUTE)}
+        assert_at(__FILE__,__LINE__){ val[0].kind_of?(OpenEhr::AM::Archetype::ConstraintModel::C_ATTRIBUTE)}
     c_attribute = val[0]
     c_attribute.children = val[3]
@@ -1843,5 +1844,5 @@
 module_eval(<<'.,.,', 'parser.y', 399)
   def _reduce_66(val, _values, result)
-        assert_at(__FILE__,__LINE__){ val[0].kind_of?(OpenEhr::AM::Archetype::Constraint_Model::C_ATTRIBUTE)}
+        assert_at(__FILE__,__LINE__){ val[0].kind_of?(OpenEhr::AM::Archetype::ConstraintModel::C_ATTRIBUTE)}
     result = val[0]
   
@@ -1852,5 +1853,5 @@
 module_eval(<<'.,.,', 'parser.y', 404)
   def _reduce_67(val, _values, result)
-        assert_at(__FILE__,__LINE__){ val[0].kind_of?(OpenEhr::AM::Archetype::Constraint_Model::C_ATTRIBUTE)}
+        assert_at(__FILE__,__LINE__){ val[0].kind_of?(OpenEhr::AM::Archetype::ConstraintModel::C_ATTRIBUTE)}
     result = val[0]
   
@@ -1862,5 +1863,5 @@
   def _reduce_68(val, _values, result)
         @@logger.debug("#{__FILE__}:#{__LINE__}: V_ATTRIBUTE_IDENTIFIER = #{val[0]}, c_existence = #{val[1]} at #{@filename}")
-    result = OpenEhr::AM::Archetype::Constraint_Model::C_SINGLE_ATTRIBUTE.new(
+    result = OpenEhr::AM::Archetype::ConstraintModel::C_SINGLE_ATTRIBUTE.new(
                                                                               :rm_attribute_name => val[0],
                                                                               :existence => val[1]
@@ -1874,7 +1875,7 @@
 module_eval(<<'.,.,', 'parser.y', 420)
   def _reduce_69(val, _values, result)
-        assert_at(__FILE__,__LINE__){ val[2].instance_of?(OpenEhr::AM::Archetype::Constraint_Model::CARDINALITY) }
+        assert_at(__FILE__,__LINE__){ val[2].instance_of?(OpenEhr::AM::Archetype::ConstraintModel::CARDINALITY) }
     @@logger.debug("#{__FILE__}:#{__LINE__}: V_ATTRIBUTE_IDENTIFIER: #{val[0]}, c_existence = #{val[1]}, c_cardinality = #{val[2]} at #{@filename}") 
-    result = OpenEhr::AM::Archetype::Constraint_Model::C_MULTIPLE_ATTRIBUTE.new(
+    result = OpenEhr::AM::Archetype::ConstraintModel::C_MULTIPLE_ATTRIBUTE.new(
                                                                                 :rm_attribute_name => val[0],
                                                                                 :existence => val[1],
@@ -1957,6 +1958,8 @@
 # reduce 86 omitted
 
-module_eval(<<'.,.,', 'parser.y', 484)
-  def _reduce_87(val, _values, result)
+# reduce 87 omitted
+
+module_eval(<<'.,.,', 'parser.y', 485)
+  def _reduce_88(val, _values, result)
         @@logger.debug("#{__FILE__}:#{__LINE__}:dadl_section attr_vals = \n#{val[0].to_yaml}")
     result = val[0]
@@ -1966,6 +1969,6 @@
 .,.,
 
-module_eval(<<'.,.,', 'parser.y', 489)
-  def _reduce_88(val, _values, result)
+module_eval(<<'.,.,', 'parser.y', 490)
+  def _reduce_89(val, _values, result)
         @@logger.debug("#{__FILE__}:#{__LINE__}:dadl_section complex_object_block = \n#{val[0].to_yaml}")
     result = val[0]
@@ -1975,6 +1978,6 @@
 .,.,
 
-module_eval(<<'.,.,', 'parser.y', 496)
-  def _reduce_89(val, _values, result)
+module_eval(<<'.,.,', 'parser.y', 497)
+  def _reduce_90(val, _values, result)
         result = Array[val[0]]
   
@@ -1983,6 +1986,6 @@
 .,.,
 
-module_eval(<<'.,.,', 'parser.y', 500)
-  def _reduce_90(val, _values, result)
+module_eval(<<'.,.,', 'parser.y', 501)
+  def _reduce_91(val, _values, result)
         result = (val[0] << val[1])
   
@@ -1991,6 +1994,6 @@
 .,.,
 
-module_eval(<<'.,.,', 'parser.y', 504)
-  def _reduce_91(val, _values, result)
+module_eval(<<'.,.,', 'parser.y', 505)
+  def _reduce_92(val, _values, result)
         result = (val[0] << val[2])
   
@@ -1999,6 +2002,6 @@
 .,.,
 
-module_eval(<<'.,.,', 'parser.y', 509)
-  def _reduce_92(val, _values, result)
+module_eval(<<'.,.,', 'parser.y', 510)
+  def _reduce_93(val, _values, result)
         @@logger.debug("#{__FILE__}:#{__LINE__}:attr_val\n attr_id = #{val[0]}, object_block = #{val[1]}")
     result = {:attr_id => val[0], :object_block => val[2]}
@@ -2008,6 +2011,6 @@
 .,.,
 
-module_eval(<<'.,.,', 'parser.y', 515)
-  def _reduce_93(val, _values, result)
+module_eval(<<'.,.,', 'parser.y', 516)
+  def _reduce_94(val, _values, result)
         @@logger.debug("#{__FILE__}:#{__LINE__}: V_ATTRIBUTE_IDENTIFIER = #{val[0]}")
     result = val[0]
@@ -2017,15 +2020,7 @@
 .,.,
 
-# reduce 94 omitted
-
-module_eval(<<'.,.,', 'parser.y', 522)
-  def _reduce_95(val, _values, result)
-        result = val[0]
-  
-    result
-  end
-.,.,
-
-module_eval(<<'.,.,', 'parser.y', 526)
+# reduce 95 omitted
+
+module_eval(<<'.,.,', 'parser.y', 523)
   def _reduce_96(val, _values, result)
         result = val[0]
@@ -2035,5 +2030,5 @@
 .,.,
 
-module_eval(<<'.,.,', 'parser.y', 531)
+module_eval(<<'.,.,', 'parser.y', 527)
   def _reduce_97(val, _values, result)
         result = val[0]
@@ -2043,5 +2038,5 @@
 .,.,
 
-module_eval(<<'.,.,', 'parser.y', 535)
+module_eval(<<'.,.,', 'parser.y', 532)
   def _reduce_98(val, _values, result)
         result = val[0]
@@ -2051,6 +2046,14 @@
 .,.,
 
-module_eval(<<'.,.,', 'parser.y', 540)
+module_eval(<<'.,.,', 'parser.y', 536)
   def _reduce_99(val, _values, result)
+        result = val[0]
+  
+    result
+  end
+.,.,
+
+module_eval(<<'.,.,', 'parser.y', 541)
+  def _reduce_100(val, _values, result)
         result = {:untyped_multiple_attr_object_block => val[0]}
   
@@ -2059,6 +2062,6 @@
 .,.,
 
-module_eval(<<'.,.,', 'parser.y', 544)
-  def _reduce_100(val, _values, result)
+module_eval(<<'.,.,', 'parser.y', 545)
+  def _reduce_101(val, _values, result)
         result = {:type_identifier => val[0], :untyped_multiple_attr_object_block => val[1]}
   
@@ -2067,6 +2070,6 @@
 .,.,
 
-module_eval(<<'.,.,', 'parser.y', 549)
-  def _reduce_101(val, _values, result)
+module_eval(<<'.,.,', 'parser.y', 550)
+  def _reduce_102(val, _values, result)
         result = {:multiple_attr_object_block_head => val[0], :keyed_objects => val[1]}
   
@@ -2075,6 +2078,6 @@
 .,.,
 
-module_eval(<<'.,.,', 'parser.y', 554)
-  def _reduce_102(val, _values, result)
+module_eval(<<'.,.,', 'parser.y', 555)
+  def _reduce_103(val, _values, result)
         result = val[0]
   
@@ -2083,6 +2086,6 @@
 .,.,
 
-module_eval(<<'.,.,', 'parser.y', 559)
-  def _reduce_103(val, _values, result)
+module_eval(<<'.,.,', 'parser.y', 560)
+  def _reduce_104(val, _values, result)
         result = Array[val[0]]
   
@@ -2091,6 +2094,6 @@
 .,.,
 
-module_eval(<<'.,.,', 'parser.y', 563)
-  def _reduce_104(val, _values, result)
+module_eval(<<'.,.,', 'parser.y', 564)
+  def _reduce_105(val, _values, result)
         result = (val[0] << val[1])
   
@@ -2099,6 +2102,6 @@
 .,.,
 
-module_eval(<<'.,.,', 'parser.y', 568)
-  def _reduce_105(val, _values, result)
+module_eval(<<'.,.,', 'parser.y', 569)
+  def _reduce_106(val, _values, result)
         @@logger.debug("#{__FILE__}:#{__LINE__}: keyed_object = #{val[0]} at #{@filename}:#{@lineno}")
     result = {:object_key => val[0], :object_block => val[2]}
@@ -2108,6 +2111,6 @@
 .,.,
 
-module_eval(<<'.,.,', 'parser.y', 574)
-  def _reduce_106(val, _values, result)
+module_eval(<<'.,.,', 'parser.y', 575)
+  def _reduce_107(val, _values, result)
         @@logger.debug("object_key: [#{val[1]}] at #{@filename}:#{@lineno}")
     result = val[1]
@@ -2117,6 +2120,6 @@
 .,.,
 
-module_eval(<<'.,.,', 'parser.y', 580)
-  def _reduce_107(val, _values, result)
+module_eval(<<'.,.,', 'parser.y', 581)
+  def _reduce_108(val, _values, result)
         result = {:untyped_single_attr_object_block => val[0]}
   
@@ -2125,6 +2128,6 @@
 .,.,
 
-module_eval(<<'.,.,', 'parser.y', 584)
-  def _reduce_108(val, _values, result)
+module_eval(<<'.,.,', 'parser.y', 585)
+  def _reduce_109(val, _values, result)
         result = {:type_identifier => val[0], :untyped_single_attr_object_block => val[1]}
   
